diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
index 9a3dc1d94..87413e3df 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
@@ -4,10 +4,11 @@ import net.minecraft.core.util.Into;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.pool.Poolable;
-import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
+@Deprecated
 public class AABB implements Poolable<AABB> {
     private static final @NotNull ObjectPool<AABB> POOL = new ObjectPool<>(new ObjectPool.PooledObjectFactory<AABB>() {
         @Override
@@ -24,27 +25,23 @@ public class AABB implements Poolable<AABB> {
     public double maxZ;
 
     @Deprecated
-    public static AABB getPermanentBB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
-    {
+    public static AABB getPermanentBB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
         return new AABB(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     @Deprecated
-    public static void deinitializePool()
-    {
+    public static void deinitializePool() {
         AABB.POOL.free();
     }
 
     @Deprecated
-    public static void initializePool()
-    {
+    public static void initializePool() {
         AABB.POOL.reset();
     }
 
     @Deprecated
     public static AABB getTemporaryBB(double minX, double minY, double minZ, double maxX,
-                                      double maxY, double maxZ)
-    {
+                                      double maxY, double maxZ) {
         return AABB.POOL.get().set(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
@@ -55,8 +52,7 @@ public class AABB implements Poolable<AABB> {
         return AABB.POOL.get().set(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
-    private AABB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
-    {
+    private AABB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
         this.minX = minX;
         this.minY = minY;
         this.minZ = minZ;
@@ -80,8 +76,7 @@ public class AABB implements Poolable<AABB> {
         this.maxZ = other.maxZ;
     }
 
-    public AABB set(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
-    {
+    public AABB set(double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
         this.minX = minX;
         this.minY = minY;
         this.minZ = minZ;
@@ -91,138 +86,108 @@ public class AABB implements Poolable<AABB> {
         return this;
     }
 
-    public AABB expand(double stretchX, double stretchY, double stretchZ)
-    {
+    public AABB expand(double stretchX, double stretchY, double stretchZ) {
         double minX = this.minX;
         double minY = this.minY;
         double minZ = this.minZ;
         double maxX = this.maxX;
         double maxY = this.maxY;
         double maxZ = this.maxZ;
-        if(stretchX < 0.0D)
-        {
+        if (stretchX < 0.0D) {
             minX += stretchX;
         }
-        if(stretchX > 0.0D)
-        {
+        if (stretchX > 0.0D) {
             maxX += stretchX;
         }
-        if(stretchY < 0.0D)
-        {
+        if (stretchY < 0.0D) {
             minY += stretchY;
         }
-        if(stretchY > 0.0D)
-        {
+        if (stretchY > 0.0D) {
             maxY += stretchY;
         }
-        if(stretchZ < 0.0D)
-        {
+        if (stretchZ < 0.0D) {
             minZ += stretchZ;
         }
-        if(stretchZ > 0.0D)
-        {
+        if (stretchZ > 0.0D) {
             maxZ += stretchZ;
         }
         return fromPool(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
-    public @NotNull AABB grow(double d, double d1, double d2)
-    {
-        double d3 = minX - d;
-        double d4 = minY - d1;
-        double d5 = minZ - d2;
-        double d6 = maxX + d;
-        double d7 = maxY + d1;
-        double d8 = maxZ + d2;
+    public @NotNull AABB grow(double d, double d1, double d2) {
+        double d3 = this.minX - d;
+        double d4 = this.minY - d1;
+        double d5 = this.minZ - d2;
+        double d6 = this.maxX + d;
+        double d7 = this.maxY + d1;
+        double d8 = this.maxZ + d2;
         return fromPool(d3, d4, d5, d6, d7, d8);
     }
 
-    public AABB cloneMove(double offX, double offY, double offZ)
-    {
-        return fromPool(minX + offX, minY + offY, minZ + offZ, maxX + offX, maxY + offY, maxZ + offZ);
+    public AABB cloneMove(double offX, double offY, double offZ) {
+        return fromPool(this.minX + offX, this.minY + offY, this.minZ + offZ, this.maxX + offX, this.maxY + offY, this.maxZ + offZ);
     }
 
-    public double clipXCollide(AABB aabb, double d)
-    {
-        if(aabb.maxY <= minY || aabb.minY >= maxY)
-        {
+    public double clipXCollide(AABB aabb, double d) {
+        if (aabb.maxY <= this.minY || aabb.minY >= this.maxY) {
             return d;
         }
-        if(aabb.maxZ <= minZ || aabb.minZ >= maxZ)
-        {
+        if (aabb.maxZ <= this.minZ || aabb.minZ >= this.maxZ) {
             return d;
         }
-        if(d > 0.0D && aabb.maxX <= minX)
-        {
-            double d1 = minX - aabb.maxX;
-            if(d1 < d)
-            {
+        if (d > 0.0D && aabb.maxX <= this.minX) {
+            double d1 = this.minX - aabb.maxX;
+            if (d1 < d) {
                 d = d1;
             }
         }
-        if(d < 0.0D && aabb.minX >= maxX)
-        {
-            double d2 = maxX - aabb.minX;
-            if(d2 > d)
-            {
+        if (d < 0.0D && aabb.minX >= this.maxX) {
+            double d2 = this.maxX - aabb.minX;
+            if (d2 > d) {
                 d = d2;
             }
         }
         return d;
     }
 
-    public double clipYCollide(AABB aabb, double d)
-    {
-        if(aabb.maxX <= minX || aabb.minX >= maxX)
-        {
+    public double clipYCollide(AABB aabb, double d) {
+        if (aabb.maxX <= this.minX || aabb.minX >= this.maxX) {
             return d;
         }
-        if(aabb.maxZ <= minZ || aabb.minZ >= maxZ)
-        {
+        if (aabb.maxZ <= this.minZ || aabb.minZ >= this.maxZ) {
             return d;
         }
-        if(d > 0.0D && aabb.maxY <= minY)
-        {
-            double d1 = minY - aabb.maxY;
-            if(d1 < d)
-            {
+        if (d > 0.0D && aabb.maxY <= this.minY) {
+            double d1 = this.minY - aabb.maxY;
+            if (d1 < d) {
                 d = d1;
             }
         }
-        if(d < 0.0D && aabb.minY >= maxY)
-        {
-            double d2 = maxY - aabb.minY;
-            if(d2 > d)
-            {
+        if (d < 0.0D && aabb.minY >= this.maxY) {
+            double d2 = this.maxY - aabb.minY;
+            if (d2 > d) {
                 d = d2;
             }
         }
         return d;
     }
 
-    public double clipZCollide(AABB aabb, double d)
-    {
-        if(aabb.maxX <= minX || aabb.minX >= maxX)
-        {
+    public double clipZCollide(AABB aabb, double d) {
+        if (aabb.maxX <= this.minX || aabb.minX >= this.maxX) {
             return d;
         }
-        if(aabb.maxY <= minY || aabb.minY >= maxY)
-        {
+        if (aabb.maxY <= this.minY || aabb.minY >= this.maxY) {
             return d;
         }
-        if(d > 0.0D && aabb.maxZ <= minZ)
-        {
-            double d1 = minZ - aabb.maxZ;
-            if(d1 < d)
-            {
+        if (d > 0.0D && aabb.maxZ <= this.minZ) {
+            double d1 = this.minZ - aabb.maxZ;
+            if (d1 < d) {
                 d = d1;
             }
         }
-        if(d < 0.0D && aabb.minZ >= maxZ)
-        {
-            double d2 = maxZ - aabb.minZ;
-            if(d2 > d)
-            {
+        if (d < 0.0D && aabb.minZ >= this.maxZ) {
+            double d2 = this.maxZ - aabb.minZ;
+            if (d2 > d) {
                 d = d2;
             }
         }
@@ -232,6 +197,7 @@ public class AABB implements Poolable<AABB> {
     public boolean intersects(AABB aabb) {
         return aabb.maxX > this.minX && aabb.minX < this.maxX && aabb.maxY > this.minY && aabb.minY < this.maxY && aabb.maxZ > this.minZ && aabb.minZ < this.maxZ;
     }
+
     public boolean intersects(double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
         return maxX > this.minX && minX < this.maxX && maxY > this.minY && minY < this.maxY && maxZ > this.minZ && minZ < this.maxZ;
     }
@@ -240,14 +206,13 @@ public class AABB implements Poolable<AABB> {
         return aabb.maxX >= this.minX && aabb.minX <= this.maxX && aabb.maxY >= this.minY && aabb.minY <= this.maxY && aabb.maxZ >= this.minZ && aabb.minZ <= this.maxZ;
     }
 
-    public @NotNull AABB move(double offX, double offY, double offZ)
-    {
-        minX += offX;
-        minY += offY;
-        minZ += offZ;
-        maxX += offX;
-        maxY += offY;
-        maxZ += offZ;
+    public @NotNull AABB move(double offX, double offY, double offZ) {
+        this.minX += offX;
+        this.minY += offY;
+        this.minZ += offZ;
+        this.maxX += offX;
+        this.maxY += offY;
+        this.maxZ += offZ;
         return this;
     }
 
@@ -256,26 +221,23 @@ public class AABB implements Poolable<AABB> {
         return this.move(vec.x, vec.y, vec.z);
     }
 
-    public boolean contains(Vec3 vec3)
-    {
-        if(vec3.x <= minX || vec3.x >= maxX)
-        {
+    public boolean contains(Vec3 vec3) {
+        if (vec3.x <= this.minX || vec3.x >= this.maxX) {
             return false;
         }
-        if(vec3.y <= minY || vec3.y >= maxY)
-        {
+        if (vec3.y <= this.minY || vec3.y >= this.maxY) {
             return false;
         }
-        return vec3.z > minZ && vec3.z < maxZ;
+        return vec3.z > this.minZ && vec3.z < this.maxZ;
     }
 
-    public double getSize()
-    {
-        double d = maxX - minX;
-        double d1 = maxY - minY;
-        double d2 = maxZ - minZ;
+    public double getSize() {
+        double d = this.maxX - this.minX;
+        double d1 = this.maxY - this.minY;
+        double d2 = this.maxZ - this.minZ;
         return (d + d1 + d2) / 3D;
     }
+
     public AABB shrink(final double n, final double n2, final double n3) {
         double minX = this.minX;
         double minY = this.minY;
@@ -304,110 +266,107 @@ public class AABB implements Poolable<AABB> {
         return fromPool(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
-    public AABB getInsetBoundingBox(double d, double d1, double d2)
-    {
-        double d3 = minX + d;
-        double d4 = minY + d1;
-        double d5 = minZ + d2;
-        double d6 = maxX - d;
-        double d7 = maxY - d1;
-        double d8 = maxZ - d2;
+    public AABB getInsetBoundingBox(double d, double d1, double d2) {
+        double d3 = this.minX + d;
+        double d4 = this.minY + d1;
+        double d5 = this.minZ + d2;
+        double d6 = this.maxX - d;
+        double d7 = this.maxY - d1;
+        double d8 = this.maxZ - d2;
         return fromPool(d3, d4, d5, d6, d7, d8);
     }
 
     @Deprecated
-    public @NotNull AABB copy()
-    {
-        return fromPool(minX, minY, minZ, maxX, maxY, maxZ);
+    public @NotNull AABB copy() {
+        return fromPool(this.minX, this.minY, this.minZ, this.maxX, this.maxY, this.maxZ);
     }
 
     @Deprecated
     public AABB copyPermanent() {
-        return fromPool(minX, minY, minZ, maxX, maxY, maxZ).copyUnpooled();
-    }
-
-	public @Nullable HitResult.Clip clip(@NotNull Vec3 start, @NotNull Vec3 end) {
-		Vec3 vMinX = start.clipX(end, minX);
-		Vec3 vMaxX = start.clipX(end, maxX);
-		Vec3 vMinY = start.clipY(end, minY);
-		Vec3 vMaxY = start.clipY(end, maxY);
-		Vec3 vMinZ = start.clipZ(end, minZ);
-		Vec3 vMaxZ = start.clipZ(end, maxZ);
-		
-		if(!containsX(vMinX)) vMinX = null;
-		if(!containsX(vMaxX)) vMaxX = null;
-		if(!containsY(vMinY)) vMinY = null;
-		if(!containsY(vMaxY)) vMaxY = null;
-		if(!containsZ(vMinZ)) vMinZ = null;
-		if(!containsZ(vMaxZ)) vMaxZ = null;
-		
-		Vec3 clipPos = null;
-		if(vMinX != null && (clipPos == null || start.distanceToSquared(vMinX) < start.distanceToSquared(clipPos))) clipPos = vMinX;
-		if(vMaxX != null && (clipPos == null || start.distanceToSquared(vMaxX) < start.distanceToSquared(clipPos))) clipPos = vMaxX;
-		if(vMinY != null && (clipPos == null || start.distanceToSquared(vMinY) < start.distanceToSquared(clipPos))) clipPos = vMinY;
-		if(vMaxY != null && (clipPos == null || start.distanceToSquared(vMaxY) < start.distanceToSquared(clipPos))) clipPos = vMaxY;
-		if(vMinZ != null && (clipPos == null || start.distanceToSquared(vMinZ) < start.distanceToSquared(clipPos))) clipPos = vMinZ;
-		if(vMaxZ != null && (clipPos == null || start.distanceToSquared(vMaxZ) < start.distanceToSquared(clipPos))) clipPos = vMaxZ;
-		
-		if(clipPos == null) return null;
-		
-		Side side = Side.NONE;
-		if(clipPos == vMinX) side = Side.WEST;
-		if(clipPos == vMaxX) side = Side.EAST;
-		if(clipPos == vMinY) side = Side.BOTTOM;
-		if(clipPos == vMaxY) side = Side.TOP;
-		if(clipPos == vMinZ) side = Side.NORTH;
-		if(clipPos == vMaxZ) side = Side.SOUTH;
-
-        return new HitResult.Clip(side, clipPos);
-	}
-
-    private boolean containsX(Vec3 vec3)
-    {
-        if(vec3 == null)
-        {
+        return fromPool(this.minX, this.minY, this.minZ, this.maxX, this.maxY, this.maxZ).copyUnpooled();
+    }
+
+    public @Nullable HitResult.Clip clip(@NotNull Vec3 start, @NotNull Vec3 end) {
+        Vec3 vMinX = start.clipX(end, this.minX);
+        Vec3 vMaxX = start.clipX(end, this.maxX);
+        Vec3 vMinY = start.clipY(end, this.minY);
+        Vec3 vMaxY = start.clipY(end, this.maxY);
+        Vec3 vMinZ = start.clipZ(end, this.minZ);
+        Vec3 vMaxZ = start.clipZ(end, this.maxZ);
+
+        if (!containsX(vMinX)) vMinX = null;
+        if (!containsX(vMaxX)) vMaxX = null;
+        if (!containsY(vMinY)) vMinY = null;
+        if (!containsY(vMaxY)) vMaxY = null;
+        if (!containsZ(vMinZ)) vMinZ = null;
+        if (!containsZ(vMaxZ)) vMaxZ = null;
+
+        Vec3 clipPos = null;
+        if (vMinX != null && (clipPos == null || start.distanceToSquared(vMinX) < start.distanceToSquared(clipPos)))
+            clipPos = vMinX;
+        if (vMaxX != null && (clipPos == null || start.distanceToSquared(vMaxX) < start.distanceToSquared(clipPos)))
+            clipPos = vMaxX;
+        if (vMinY != null && (clipPos == null || start.distanceToSquared(vMinY) < start.distanceToSquared(clipPos)))
+            clipPos = vMinY;
+        if (vMaxY != null && (clipPos == null || start.distanceToSquared(vMaxY) < start.distanceToSquared(clipPos)))
+            clipPos = vMaxY;
+        if (vMinZ != null && (clipPos == null || start.distanceToSquared(vMinZ) < start.distanceToSquared(clipPos)))
+            clipPos = vMinZ;
+        if (vMaxZ != null && (clipPos == null || start.distanceToSquared(vMaxZ) < start.distanceToSquared(clipPos)))
+            clipPos = vMaxZ;
+
+        if (clipPos == null) return null;
+
+        Side side = Side.NONE;
+        if (clipPos == vMinX) side = Side.WEST;
+        if (clipPos == vMaxX) side = Side.EAST;
+        if (clipPos == vMinY) side = Side.BOTTOM;
+        if (clipPos == vMaxY) side = Side.TOP;
+        if (clipPos == vMinZ) side = Side.NORTH;
+        if (clipPos == vMaxZ) side = Side.SOUTH;
+
+        return new HitResult.Clip(side, clipPos.asJomlVec());
+    }
+
+    private boolean containsX(Vec3 vec3) {
+        if (vec3 == null) {
             return false;
-        } else
-        {
-            return vec3.y >= minY && vec3.y <= maxY && vec3.z >= minZ && vec3.z <= maxZ;
+        } else {
+            return vec3.y >= this.minY && vec3.y <= this.maxY && vec3.z >= this.minZ && vec3.z <= this.maxZ;
         }
     }
 
-    private boolean containsY(Vec3 vec3)
-    {
-        if(vec3 == null)
-        {
+    private boolean containsY(Vec3 vec3) {
+        if (vec3 == null) {
             return false;
-        } else
-        {
-            return vec3.x >= minX && vec3.x <= maxX && vec3.z >= minZ && vec3.z <= maxZ;
+        } else {
+            return vec3.x >= this.minX && vec3.x <= this.maxX && vec3.z >= this.minZ && vec3.z <= this.maxZ;
         }
     }
 
-    private boolean containsZ(Vec3 vec3)
-    {
-        if(vec3 == null)
-        {
+    private boolean containsZ(Vec3 vec3) {
+        if (vec3 == null) {
             return false;
-        } else
-        {
-            return vec3.x >= minX && vec3.x <= maxX && vec3.y >= minY && vec3.y <= maxY;
+        } else {
+            return vec3.x >= this.minX && vec3.x <= this.maxX && vec3.y >= this.minY && vec3.y <= this.maxY;
         }
     }
 
-    public void setBB(AABB aabb)
-    {
-        minX = aabb.minX;
-        minY = aabb.minY;
-        minZ = aabb.minZ;
-        maxX = aabb.maxX;
-        maxY = aabb.maxY;
-        maxZ = aabb.maxZ;
+    public void setBB(AABB aabb) {
+        this.minX = aabb.minX;
+        this.minY = aabb.minY;
+        this.minZ = aabb.minZ;
+        this.maxX = aabb.maxX;
+        this.maxY = aabb.maxY;
+        this.maxZ = aabb.maxZ;
     }
 
     @Override
-	public String toString()
-    {
-        return "box[" + minX + ", " + minY + ", " + minZ + " -> " + maxX + ", " + maxY + ", " + maxZ + "]";
+    public String toString() {
+        return "box[" + this.minX + ", " + this.minY + ", " + this.minZ + " -> " + this.maxX + ", " + this.maxY + ", " + this.maxZ + "]";
+    }
+
+    public @NotNull AABBd asJomlAABB() {
+        return new AABBd(this.minX, this.minY, this.minZ, this.maxX, this.maxY, this.maxZ);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java b/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java
index 6426bc226..d019aefe3 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java
@@ -2,18 +2,25 @@ package net.minecraft.core.util.phys;
 
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
 public sealed class HitResult permits HitResult.Tile, HitResult.Entity, HitResult.Clip {
-    public final @NotNull Vec3 location;
+    public final @NotNull Vector3dc location;
 
-    public HitResult(@NotNull Vec3 location) {
-        this.location = location.copyPooled();
+    public HitResult(double x, double y, double z) {
+        this.location = new Vector3d(x, y, z);
+    }
+
+    public HitResult(@NotNull Vector3dc location) {
+        this.location = new Vector3d(location);
     }
     public double distanceToSquared(final @NotNull net.minecraft.core.entity.Entity entity) {
-        final double diffX = this.location.x - entity.x;
-        final double diffY = this.location.y - entity.y;
-        final double diffZ = this.location.z - entity.z;
+        final double diffX = this.location.x() - entity.x;
+        final double diffY = this.location.y() - entity.y;
+        final double diffZ = this.location.z() - entity.z;
         return diffX * diffX + diffY * diffY + diffZ * diffZ;
     }
     public double distanceTo(final @NotNull net.minecraft.core.entity.Entity entity) {
@@ -21,10 +28,10 @@ public sealed class HitResult permits HitResult.Tile, HitResult.Entity, HitResul
     }
 
     public final static class Tile extends HitResult {
-        public final @NotNull TilePos tilePos;
+        public final @NotNull TilePosc tilePos;
         public final @NotNull Side side;
-        public Tile(@NotNull TilePos tilePos, @NotNull Side side, @NotNull Vec3 vec3) {
-            super(vec3);
+        public Tile(@NotNull TilePosc tilePos, @NotNull Side side, @NotNull Vector3dc location) {
+            super(location);
             this.tilePos = new TilePos(tilePos);
             this.side = side;
         }
@@ -33,15 +40,15 @@ public sealed class HitResult permits HitResult.Tile, HitResult.Entity, HitResul
     public final static class Entity extends HitResult {
         public final @NotNull net.minecraft.core.entity.Entity entity;
         public Entity(@NotNull net.minecraft.core.entity.Entity entity) {
-            super(Vec3.fromPool(entity.x, entity.y, entity.z));
+            super(entity.x, entity.y, entity.z);
             this.entity = entity;
         }
     }
 
     public final static class Clip extends HitResult {
         public final @NotNull Side side;
-        public Clip( @NotNull Side side, @NotNull Vec3 vec3) {
-            super(vec3);
+        public Clip( @NotNull Side side, @NotNull Vector3dc location) {
+            super(location);
             this.side = side;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java b/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java
index 58964147c..101f6128a 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java
@@ -6,10 +6,11 @@ import net.minecraft.core.util.pool.Poolable;
 import org.jetbrains.annotations.NotNull;
 import net.minecraft.core.util.pool.ObjectPool;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
 
+@Deprecated
 public class Vec3
-    implements Poolable<Vec3>, Into<Vec3>
-{
+    implements Poolable<Vec3>, Into<Vec3> {
     private static final @NotNull ObjectPool<Vec3> POOL = new ObjectPool<>(new ObjectPool.PooledObjectFactory<Vec3>() {
         @Override
         public @NotNull Vec3 createDefault() {
@@ -22,26 +23,22 @@ public class Vec3
     public double z;
 
     @Deprecated
-    public static Vec3 getPermanentVec3(double x, double y, double z)
-    {
+    public static Vec3 getPermanentVec3(double x, double y, double z) {
         return new Vec3(x, y, z);
     }
 
     @Deprecated
-    public static void deinitializePool()
-    {
+    public static void deinitializePool() {
         Vec3.POOL.free();
     }
 
     @Deprecated
-    public static void initializePool()
-    {
+    public static void initializePool() {
         Vec3.POOL.reset();
     }
 
     @Deprecated
-    public static Vec3 getTempVec3(double x, double y, double z)
-    {
+    public static Vec3 getTempVec3(double x, double y, double z) {
         return Vec3.POOL.get().set(x, y, z);
     }
 
@@ -55,13 +52,13 @@ public class Vec3
     }
 
     private Vec3(double x, double y, double z) {
-        if(x == -0D) {
+        if (x == -0D) {
             x = 0.0D;
         }
-        if(y == -0D) {
+        if (y == -0D) {
             y = 0.0D;
         }
-        if(z == -0D) {
+        if (z == -0D) {
             z = 0.0D;
         }
         this.x = x;
@@ -86,144 +83,122 @@ public class Vec3
         this.z = other.z;
     }
 
-    public Vec3 set(double x, double y, double z)
-    {
+    public Vec3 set(double x, double y, double z) {
         this.x = x;
         this.y = y;
         this.z = z;
         return this;
     }
 
-    public Vec3 vectorTo(Vec3 vec3)
-    {
-        return fromPool(vec3.x - x, vec3.y - y, vec3.z - z);
+    public Vec3 vectorTo(Vec3 vec3) {
+        return fromPool(vec3.x - this.x, vec3.y - this.y, vec3.z - this.z);
     }
 
-    public Vec3 normalize()
-    {
-        double d = MathHelper.sqrt(x * x + y * y + z * z);
-        if(d < 0.0001D)
-        {
+    public Vec3 normalize() {
+        double d = MathHelper.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
+        if (d < 0.0001D) {
             return fromPool(0.0D, 0.0D, 0.0D);
-        } else
-        {
-            return scale(1/d);
+        } else {
+            return scale(1 / d);
         }
     }
+
     public double dotProduct(final Vec3 vec3) {
         return this.x * vec3.x + this.y * vec3.y + this.z * vec3.z;
     }
-    public Vec3 crossProduct(Vec3 vec3)
-    {
-        return fromPool(y * vec3.z - z * vec3.y, z * vec3.x - x * vec3.z, x * vec3.y - y * vec3.x);
+
+    public Vec3 crossProduct(Vec3 vec3) {
+        return fromPool(this.y * vec3.z - this.z * vec3.y, this.z * vec3.x - this.x * vec3.z, this.x * vec3.y - this.y * vec3.x);
     }
 
-    public @NotNull Vec3 add(double x, double y, double z)
-    {
+    public @NotNull Vec3 add(double x, double y, double z) {
         return fromPool(this.x + x, this.y + y, this.z + z);
     }
 
-    public Vec3 scale(double scalar){
+    public Vec3 scale(double scalar) {
         return fromPool(this.x * scalar, this.y * scalar, this.z * scalar);
     }
 
-    public double distanceTo(Vec3 vec3)
-    {
-        double diffX = vec3.x - x;
-        double diffY = vec3.y - y;
-        double diffZ = vec3.z - z;
+    public double distanceTo(Vec3 vec3) {
+        double diffX = vec3.x - this.x;
+        double diffY = vec3.y - this.y;
+        double diffZ = vec3.z - this.z;
         return MathHelper.sqrt(diffX * diffX + diffY * diffY + diffZ * diffZ);
     }
 
-    public double distanceToSquared(Vec3 vec3)
-    {
-        double diffX = vec3.x - x;
-        double diffY = vec3.y - y;
-        double diffZ = vec3.z - z;
+    public double distanceToSquared(Vec3 vec3) {
+        double diffX = vec3.x - this.x;
+        double diffY = vec3.y - this.y;
+        double diffZ = vec3.z - this.z;
         return diffX * diffX + diffY * diffY + diffZ * diffZ;
     }
 
-    public double distanceToSquared(double x, double y, double z)
-    {
+    public double distanceToSquared(double x, double y, double z) {
         double diffX = x - this.x;
         double diffY = y - this.y;
         double diffZ = z - this.z;
         return diffX * diffX + diffY * diffY + diffZ * diffZ;
     }
 
-    public double length()
-    {
-        return MathHelper.sqrt(x * x + y * y + z * z);
+    public double length() {
+        return MathHelper.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
     }
 
-    public @Nullable Vec3 clipX(@NotNull Vec3 vec3, double d)
-    {
-        double diffX = vec3.x - x;
-        double diffY = vec3.y - y;
-        double diffZ = vec3.z - z;
-        if(diffX * diffX < 1E-007D)
-        {
+    public @Nullable Vec3 clipX(@NotNull Vec3 vec3, double d) {
+        double diffX = vec3.x - this.x;
+        double diffY = vec3.y - this.y;
+        double diffZ = vec3.z - this.z;
+        if (diffX * diffX < 1E-007D) {
             return null;
         }
-        double d4 = (d - x) / diffX;
-        if(d4 < 0.0D || d4 > 1.0D)
-        {
+        double d4 = (d - this.x) / diffX;
+        if (d4 < 0.0D || d4 > 1.0D) {
             return null;
-        } else
-        {
-            return fromPool(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+        } else {
+            return fromPool(this.x + diffX * d4, this.y + diffY * d4, this.z + diffZ * d4);
         }
     }
 
-    public Vec3 clipY(Vec3 vec3, double d)
-    {
-        double diffX = vec3.x - x;
-        double diffY = vec3.y - y;
-        double diffZ = vec3.z - z;
-        if(diffY * diffY < 1.0000000116860974E-007D)
-        {
+    public Vec3 clipY(Vec3 vec3, double d) {
+        double diffX = vec3.x - this.x;
+        double diffY = vec3.y - this.y;
+        double diffZ = vec3.z - this.z;
+        if (diffY * diffY < 1.0000000116860974E-007D) {
             return null;
         }
-        double d4 = (d - y) / diffY;
-        if(d4 < 0.0D || d4 > 1.0D)
-        {
+        double d4 = (d - this.y) / diffY;
+        if (d4 < 0.0D || d4 > 1.0D) {
             return null;
-        } else
-        {
-            return fromPool(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+        } else {
+            return fromPool(this.x + diffX * d4, this.y + diffY * d4, this.z + diffZ * d4);
         }
     }
 
-    public Vec3 clipZ(Vec3 vec3, double d)
-    {
-        double diffX = vec3.x - x;
-        double diffY = vec3.y - y;
-        double diffZ = vec3.z - z;
-        if(diffZ * diffZ < 1.0000000116860974E-007D)
-        {
+    public Vec3 clipZ(Vec3 vec3, double d) {
+        double diffX = vec3.x - this.x;
+        double diffY = vec3.y - this.y;
+        double diffZ = vec3.z - this.z;
+        if (diffZ * diffZ < 1.0000000116860974E-007D) {
             return null;
         }
-        double d4 = (d - z) / diffZ;
-        if(d4 < 0.0D || d4 > 1.0D)
-        {
+        double d4 = (d - this.z) / diffZ;
+        if (d4 < 0.0D || d4 > 1.0D) {
             return null;
-        } else
-        {
-            return fromPool(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+        } else {
+            return fromPool(this.x + diffX * d4, this.y + diffY * d4, this.z + diffZ * d4);
         }
     }
 
     @Override
-	public String toString()
-    {
-        return "(" + x + ", " + y + ", " + z + ")";
+    public String toString() {
+        return "(" + this.x + ", " + this.y + ", " + this.z + ")";
     }
 
     public Vec3 lerp(final Vec3 vec3, final double progress) {
         return fromPool(this.x + (vec3.x - this.x) * progress, this.y + (vec3.y - this.y) * progress, this.z + (vec3.z - this.z) * progress);
     }
-    public void rotateAroundX(float radians)
-    {
+
+    public void rotateAroundX(float radians) {
         final float cos = MathHelper.cos(radians);
         final float sin = MathHelper.sin(radians);
         final double x = this.x;
@@ -234,8 +209,7 @@ public class Vec3
         this.z = z;
     }
 
-    public void rotateAroundY(float radians)
-    {
+    public void rotateAroundY(float radians) {
         final float cos = MathHelper.cos(radians);
         final float sin = MathHelper.sin(radians);
         final double x = this.x * cos + this.z * sin;
@@ -245,6 +219,7 @@ public class Vec3
         this.y = y;
         this.z = z;
     }
+
     public void rotateAroundZ(final float radians) {
         final float cos = MathHelper.cos(radians);
         final float sin = MathHelper.sin(radians);
@@ -255,4 +230,8 @@ public class Vec3
         this.y = y;
         this.z = z;
     }
+
+    public @NotNull Vector3d asJomlVec() {
+        return new Vector3d(this.x, this.y, this.z);
+    }
 }
